xfstests: Fix some file permission.
[xfstests-dev.git] / 242
1 #! /bin/bash
2 # FS QA Test No. 242
3 #
4 # Test XFS_IOC_ZERO_RANGE
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2010 Red Hat.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24 # creator
25 owner=dchinner@redhat.com
26
27 seq=`basename $0`
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=1        # failure is the default!
33
34 _cleanup()
35 {
36     rm -f $tmp.*
37 }
38
39 trap "_cleanup ; exit \$status" 0 1 2 3 15
40
41 # get standard environment, filters and checks
42 . ./common.rc
43 . ./common.filter
44
45 # real QA test starts here
46 _supported_fs xfs
47 _supported_os Linux
48
49 _test_io_zero()
50 {
51         $XFS_IO_PROG -c "zero help" 2>&1 | \
52                         grep 'command "zero" not found' > /dev/null
53         echo $?
54 }
55
56 [ $(_test_io_zero) -eq 0 ] && _notrun "zero command not supported"
57
58 die_now()
59 {
60         status=1
61         exit
62 }
63
64 _filter_bmap()
65 {
66     awk '$3 ~ /hole/ { print $1, $2, $3; next }
67          $7 ~ /10000/ { print $1, $2, "unwritten"; next }
68          $7 ~ /00000/ {print $1, $2, "data" }'
69 }
70
71 # test the different corner cases for zeroing a range:
72 #
73 #       1. into a hole
74 #       2. into allocated space
75 #       3. into unwritten space
76 #       4. hole -> data
77 #       5. hole -> unwritten
78 #       6. data -> hole
79 #       7. data -> unwritten
80 #       8. unwritten -> hole
81 #       9. unwritten -> data
82 #       10. hole -> data -> hole
83 #       11. data -> hole -> data
84 #       12. unwritten -> data -> unwritten
85 #       13. data -> unwritten -> data
86
87 testfile=$TEST_DIR/242.$$
88
89 echo "  1. into a hole"
90 rm -f $testfile
91 $XFS_IO_PROG -f -c "truncate 20k" \
92         -c "zero 4k 8k" \
93         -c "bmap -vp" $testfile | _filter_bmap
94 [ $? -ne 0 ] && die_now
95
96 echo "  2. into allocated space"
97 rm -f $testfile
98 $XFS_IO_PROG -f -c "truncate 20k" \
99         -c "pwrite 0 20k" -c "fsync" \
100         -c "zero 4k 8k" \
101         -c "bmap -vp" $testfile | _filter_bmap
102 [ $? -ne 0 ] && die_now
103
104 echo "  3. into unwritten space"
105 rm -f $testfile
106 $XFS_IO_PROG -f -c "truncate 20k" \
107         -c "resvsp 0 20k" \
108         -c "zero 4k 8k" \
109         -c "bmap -vp" $testfile | _filter_bmap
110 [ $? -ne 0 ] && die_now
111
112 echo "  4. hole -> data"
113 rm -f $testfile
114 $XFS_IO_PROG -f -c "truncate 20k" \
115         -c "pwrite 8k 8k" -c "fsync" \
116         -c "zero 4k 8k" \
117         -c "bmap -vp" $testfile | _filter_bmap
118 [ $? -ne 0 ] && die_now
119
120 echo "  5. hole -> unwritten"
121 rm -f $testfile
122 $XFS_IO_PROG -f -c "truncate 20k" \
123         -c "resvsp 8k 8k" \
124         -c "zero 4k 8k" \
125         -c "bmap -vp" $testfile | _filter_bmap
126 [ $? -ne 0 ] && die_now
127
128 echo "  6. data -> hole"
129 rm -f $testfile
130 $XFS_IO_PROG -f -c "truncate 20k" \
131         -c "pwrite 0 8k" -c "fsync" \
132         -c "zero 4k 8k" \
133         -c "bmap -vp" $testfile | _filter_bmap
134 [ $? -ne 0 ] && die_now
135
136 echo "  7. data -> unwritten"
137 rm -f $testfile
138 $XFS_IO_PROG -f -c "truncate 20k" \
139         -c "pwrite 0 8k" -c "fsync" \
140         -c "resvsp 8k 8k" \
141         -c "zero 4k 8k" \
142         -c "bmap -vp" $testfile | _filter_bmap
143 [ $? -ne 0 ] && die_now
144
145 echo "  8. unwritten -> hole"
146 rm -f $testfile
147 $XFS_IO_PROG -f -c "truncate 20k" \
148         -c "resvsp 0 8k" \
149         -c "zero 4k 8k" \
150         -c "bmap -vp" $testfile | _filter_bmap
151 [ $? -ne 0 ] && die_now
152
153 echo "  9. unwritten -> data"
154 rm -f $testfile
155 $XFS_IO_PROG -f -c "truncate 20k" \
156         -c "resvsp 0 8k" \
157         -c "pwrite 8k 8k" -c "fsync" \
158         -c "zero 4k 8k" \
159         -c "bmap -vp" $testfile | _filter_bmap
160 [ $? -ne 0 ] && die_now
161
162 echo "  10. hole -> data -> hole"
163 rm -f $testfile
164 $XFS_IO_PROG -f -c "truncate 20k" \
165         -c "pwrite 8k 4k" -c "fsync" \
166         -c "zero 4k 12k" \
167         -c "bmap -vp" $testfile | _filter_bmap
168 [ $? -ne 0 ] && die_now
169
170 echo "  11. data -> hole -> data"
171 rm -f $testfile
172 $XFS_IO_PROG -f -c "truncate 20k" \
173         -c "resvsp 0 20k" \
174         -c "pwrite 0 8k" \
175         -c "pwrite 12k 8k" -c "fsync" \
176         -c "unresvsp 8k 4k" \
177         -c "zero 4k 12k" \
178         -c "bmap -vp" $testfile | _filter_bmap
179 [ $? -ne 0 ] && die_now
180
181 echo "  12. unwritten -> data -> unwritten"
182 rm -f $testfile
183 $XFS_IO_PROG -f -c "truncate 20k" \
184         -c "resvsp 0 20k" \
185         -c "pwrite 8k 4k" -c "fsync" \
186         -c "zero 4k 12k" \
187         -c "bmap -vp" $testfile | _filter_bmap
188 [ $? -ne 0 ] && die_now
189
190
191 echo "  13. data -> unwritten -> data"
192 rm -f $testfile
193 $XFS_IO_PROG -f -c "truncate 20k" \
194         -c "resvsp 0 20k" \
195         -c "pwrite 0k 8k" -c "fsync" \
196         -c "pwrite 12k 8k" -c "fsync" \
197         -c "zero 4k 12k" \
198         -c "bmap -vp" $testfile | _filter_bmap
199 [ $? -ne 0 ] && die_now
200
201 status=0 ; exit